#ifndef _PHP_ORBIT_H
#define _PHP_ORBIT_H

#include "config.h"
#include "php_config.h"
#include "php.h"
#include "zend_compile.h"
#include "php_globals.h"
#include "phorb.h"

#ifdef PHP_WIN32
#define PHP_ORBIT_API	__declspec(dllexport)
#else
#define PHP_ORBIT_API
#endif

#if HAVE_ORBIT
#include <glib.h>
#include <orbit/orbit.h>

#ifdef ZTS
#include "TSRM.h"
#endif

extern zend_module_entry orbit_module_entry;

#define orbit_module_ptr	&orbit_module_entry

PHP_MINIT_FUNCTION(orbit);
PHP_RINIT_FUNCTION(orbit);
PHP_MSHUTDOWN_FUNCTION(orbit);
PHP_MINFO_FUNCTION(orbit);

PHP_FUNCTION(orbit_load_idl);
PHP_FUNCTION(orbit_exception_handler);
PHP_FUNCTION(orbit_set_cpp_arguments);

ZEND_BEGIN_MODULE_GLOBALS(orbit)
	CORBA_ORB		orb;
	CORBA_Environment	ev;
	GHashTable		*idl_cache;
	GSList			*idls;
	gchar			*orbit_cpp_args;
	char			*exception_handler;
	zval			*exception;
	int			exception_counter;
	int			active, counter;
ZEND_END_MODULE_GLOBALS(orbit)

#ifdef ZTS
# define OrbSLS_D	zend_orbit_globals *orbit_globals
# define OrbSLS_DC	,OrbSLS_D
# define OrbSLS_C	orbit_globals
# define OrbSLS_CC	OrbSLS_C
# define OrbSG(v)	(orbit_globals->v)
# define OrbSLS_FETCH()	zend_orbit_globals \
			*orbit_globals = ts_resource(orbit_globals_id)
#else
# define OrbSLS_D
# define OrbSLS_DC
# define OrbSLS_C
# define OrbSLS_CC
# define OrbSG(v)	(orbit_globals.v)
# define OrbSLS_FETCH()
extern zend_orbit_globals orbit_globals;
#endif

#define phpext_orbit_ptr	orbit_module_ptr

#else

#define phpext_orbit_ptr	NULL

#endif /* HAVE_ORBIT */

#endif
